//+------------------------------------------------------------------+
//| Babypips.mq4.mq4
//| Copyright  2007, Derik Breytenbach
//| http://www.babypips.com/school/setup_your_system_in_six_steps.html
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Derik Breytenbach"
#property link      "http://www.babypips.com/blogs/pip-my-system/so_youve_finished_the_school_o.html"

// EMA periods
extern int     FastEMA=5;
extern int     SlowEMA=10;

// Slow Stochastic input values
extern int     Kperiod=10;
extern int     Dperiod=3;
extern int     slowing=3;

// RSI Period
extern int     RsiPeriod=9;

// MACD input values
extern int     MACDFastEMA = 12;
extern int     MACDSlowEMA = 26;
extern int     MACDSignal = 9;

// Define the maximum alowwable stoploss and tradesize (number of lots traded)
extern double  Max_Stoploss = 30;
extern double  Tradesize=0.1;

int init ()
{
  return(0);
}

int deinit()
{
  return(0);
}    

// Subroutine to calculate the profit value for a long trade. You can now call this function in OrderSend()
double Long_Profit()
   {
   double Lowest_Value = Low[iLowest(NULL,PERIOD_M15,MODE_LOW,11,1)];         
         double Long_Profit = MathRound(Ask/Point/100);  
         Long_Profit = Long_Profit*100*Point;
         if (Long_Profit-Ask<0)
            {
            Long_Profit = Long_Profit + 50*Point;
            }
         if (Long_Profit-Ask<Ask-Lowest_Value)
            {
            Long_Profit = Ask+Ask-Lowest_Value;
            }
   return(Long_Profit);
   }

// Subroutine to calculate the profit value for a short trade. You can now call this function in OrderSend()
double Short_Profit()
   {      
   double Highest_Value = High[iHighest(NULL,PERIOD_M15,MODE_HIGH,11,1)];
         double Short_Profit = MathRound(Bid/Point/100);  
         Short_Profit = Short_Profit*100*Point;
         if (Bid-Short_Profit<0)
            {
            Short_Profit = Short_Profit - 50*Point;
            }
         if (Bid-Short_Profit<Highest_Value-Bid)
            {
            Short_Profit = Bid+Bid-Highest_Value;
            } 
   return(Short_Profit);
   }

// Subroutine to determine if the entry rules are met, place take profit and stoploss values when you open the order
void Babypips_Entry()
   {
   int ticket;  
   double EMA1_M15 = iMA(NULL, PERIOD_M15, FastEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
   double EMA2_M15 = iMA(NULL, PERIOD_M15, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
   double EMA3_M15 = iMA(NULL, PERIOD_M15, FastEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
   double EMA4_M15 = iMA(NULL, PERIOD_M15, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
                     
   double EMA1_H4 = iMA(NULL, PERIOD_H4, FastEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
   double EMA2_H4 = iMA(NULL, PERIOD_H4, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, 0);
  
   double StochMain0_M15 = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_MAIN,0);
   double StochSignal0_M15 = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_SIGNAL,0); 
   
   double StochMain0_H4 = iStochastic(NULL, PERIOD_H4, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_MAIN,0);
   double StochSignal0_H4 = iStochastic(NULL, PERIOD_H4, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_SIGNAL,0);
   
   double StochMain1_M15 = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_MAIN,1);
   double StochSignal1_M15 = iStochastic(NULL, PERIOD_M15, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_SIGNAL,1); 
   
   double StochMain1_H4 = iStochastic(NULL, PERIOD_H4, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_MAIN,1);
   double StochSignal1_H4 = iStochastic(NULL, PERIOD_H4, Kperiod, Dperiod, slowing, MODE_LWMA, PRICE_CLOSE, MODE_SIGNAL,1);
   
   double RSI_M15 = iRSI( NULL, PERIOD_M15, RsiPeriod, PRICE_CLOSE, 0);     
   double RSI_H4 = iRSI( NULL, PERIOD_H4, RsiPeriod, PRICE_CLOSE, 0);

   double MACD_Main1_M15 = iMACD(NULL, PERIOD_M15, MACDFastEMA, MACDSlowEMA, MACDSignal, PRICE_CLOSE, MODE_MAIN, 0);
   double MACD_Main2_M15 = iMACD(NULL, PERIOD_M15, MACDFastEMA, MACDSlowEMA, MACDSignal, PRICE_CLOSE, MODE_MAIN, 1);

   double Highest_Value = High[iHighest(NULL,PERIOD_M15,MODE_HIGH,11,1)];
   double Lowest_Value = Low[iLowest(NULL,PERIOD_M15,MODE_LOW,11,1)];
      
   if(EMA1_H4 > EMA2_H4 && RSI_H4 > 50 && StochMain0_H4 > StochMain1_H4 && StochSignal0_H4 > StochSignal1_H4 && StochMain0_H4 < 80 && OrdersTotal()<1)
      {
      if (EMA1_M15 > EMA2_M15 && EMA3_M15 < EMA4_M15 && RSI_M15 > 50 && StochMain0_M15 > StochMain1_M15 && StochSignal0_M15 > StochSignal1_M15 && StochMain0_M15 < 80 && MACD_Main1_M15 > MACD_Main2_M15 && Lowest_Value > Ask-Max_Stoploss*Point) 
         {    
         ticket=OrderSend(Symbol(),OP_BUY,Tradesize,Ask,5,Lowest_Value,Long_Profit(),0,"Babypips",0,Green);
         }
      }
   if(EMA1_H4 < EMA2_H4 && RSI_H4 < 50 && StochMain0_H4 < StochMain1_H4 && StochSignal0_H4 < StochSignal1_H4 && StochMain0_H4 > 20 && OrdersTotal()<1)
      {
      if (EMA1_M15 < EMA2_M15 && EMA3_M15 > EMA4_M15 && RSI_M15 < 50 && StochMain0_M15 < StochMain1_M15 && StochSignal0_M15 < StochSignal1_M15 && StochMain0_M15 > 20 && MACD_Main1_M15 < MACD_Main2_M15 && Highest_Value < Bid+Max_Stoploss*Point)  
         {                 
         ticket=OrderSend(Symbol(),OP_SELL,Tradesize,Bid,5,Highest_Value,Short_Profit(),0,"Babypips",0,Red);
         }
      }
   } 

int start()
{    
   Babypips_Entry();   
   return (0);
}